package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.RmsCarrier;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface RmsCarrierMapper extends IBaseMapper<RmsCarrier, BigDecimal> {

    //展示承运商信息
    List<Map<String, Object>> getCarrierList(Map<String, Object> mapVal);

    //    根据id值展示承运商信息
    List<Map<String,Object>> selectCarrierById(BigDecimal id);
    //递增序列号
    @Select("SELECT seq__RMS_CARRIER.nextval FROM dual")
    BigDecimal getCarrierId();

    //通过承运商名称查承运商主键
    Integer selectParameterCarrierName(String carrierName);

//    获得当前表中的最大id
    BigDecimal getMaxCarrierId();

    Map<String,Object> getCarrierNameById(BigDecimal id);

    //通过承运商SSO主键查询承运商ID
    BigDecimal getCarrierIdByCarrierSSOId(String carrierSSOId);
}