package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.CommonSeq;
import com.steerinfo.dil.mapper.RmsLineGatepostCalculateMapper;
import com.steerinfo.dil.mapper.RmsLineMapper;
import com.steerinfo.dil.mapper.RmsLineSegemntMapper;
import com.steerinfo.dil.model.RmsLine;
import com.steerinfo.dil.model.RmsLineGatepostCalculate;
import com.steerinfo.dil.model.RmsLineSegemnt;
import com.steerinfo.dil.service.IRmsLineSegemntService;
import com.steerinfo.dil.service.IRmsLineService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * RmsLine服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-23 07:22
 * 类描述
 * 修订历史：
 * 日期：2021-11-23
 * 作者：generator
 * 参考：
 * 描述：RmsLine服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "rmsLineService")
public class RmsLineServiceImpl implements IRmsLineService {

    @Autowired
    private RmsLineMapper rmsLineMapper;

    @Autowired
    CommonSeq commonSeq;

    @Autowired
    RmsLineSegemntMapper rmsLineSegemntMapper;

    @Autowired
    private RmsLineGatepostCalculateMapper rmsLineGatepostCalculateMapper;


    @Transactional
    @Override
    public int insertSelective(Map<String, Object> map) {
        //添加线路
        RmsLine rmsLine = new RmsLine();
        int lineId = commonSeq.getId("seq_RMS_LINE");
        rmsLine.setLineId(new BigDecimal(lineId));
        rmsLine.setLineName((String) map.get("line_name"));
        rmsLine.setLineType(DataChange.dataToBigDecimal(map.get("line_type")).intValue());
        rmsLine.setLineNo(DataChange.generateEightDigitsNumber("YSXL", lineId));
        rmsLine.setSpellNumber(DataChange.dataToBigDecimal(map.get("spellNumber")).intValue());
        rmsLine.setDeleted(0);
        rmsLine.setInsertTime(new Date());
        //添加线路子表数据 以及线路子表的子表
        List<Map<String, Object>> linkList = (List<Map<String, Object>>) map.get("linkList");
        RmsLineSegemnt rmsLineSegemnt = new RmsLineSegemnt();
        rmsLineSegemnt.setLineId(new BigDecimal(lineId));   //添加线路主键
        rmsLineSegemnt.setDeleted(0);
        rmsLineSegemnt.setInsertTime(new Date());
        int i = 1, j = 1;
        for (Map<String, Object> linkMap : linkList) {
            int segmentId = commonSeq.getId("seq_RMS_LINE_SEGEMNT");
            rmsLineSegemnt.setId(new BigDecimal(segmentId));
            rmsLineSegemnt.setSegmentSqe(new BigDecimal(i++)); //设置路段顺序号
            rmsLineSegemnt.setSegmentStartNodeId(DataChange.dataToBigDecimal(linkMap.get("linkId")));//设置线路类型（进厂、出厂）等
            List<Integer> params = (List<Integer>) linkMap.get("gateGuard"); //作业点
            //添加线路子表的子表
            RmsLineGatepostCalculate rmsLineGatepostCalculate = new RmsLineGatepostCalculate();
            rmsLineGatepostCalculate.setSegmentId(new BigDecimal(segmentId)); //添加线路子表主键
            rmsLineGatepostCalculate.setInsertTime(new Date());
            for (Integer id : params) { //可能会有多个作业点
                rmsLineGatepostCalculate.setId(new BigDecimal(commonSeq.getId("seq_line_gate_calc")));
                rmsLineGatepostCalculate.setGateCalId(new BigDecimal(id));
                rmsLineGatepostCalculate.setDeleted(new BigDecimal(0));
                j += rmsLineGatepostCalculateMapper.insertSelective(rmsLineGatepostCalculate);
            }
            j += rmsLineSegemntMapper.insertSelective(rmsLineSegemnt);
        }
        j += rmsLineMapper.insertSelective(rmsLine);
        return j;
    }

    @Override
    public Map<String, Object> getRmsLine(BigDecimal lineId) {
        return rmsLineMapper.getRmsLine(lineId);
    }

    @Override
    public int updateByPrimaryKeySelective(RmsLine rmsLine) {
        return rmsLineMapper.updateByPrimaryKeySelective(rmsLine);
    }

    @Override
    public int getOmstruckOrderNumber(BigDecimal lineId) {
        return rmsLineMapper.getOmstruckOrderNumber(lineId);
    }
}
